unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, GenVals, Grids, Menus, Unit2;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    Label3: TLabel;
    Label4: TLabel;
    StringGrid5: TStringGrid;
    Label5: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    About1: TMenuItem;
    GenVals1: TGenVals;
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure GenVals1NotPositive(Sender: TObject);
    procedure GenVals1NotSymmetrical(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.BitBtn3Click(Sender: TObject);
var
i,j: Word;
begin
for i:=0 to 3 do
for j:=0 to 3 do
    begin
    GenVals1.Mass^[i+1, j+1]:=StrToInt(StringGrid1.Cells[i,j]);
    GenVals1.Stiff^[i+1, j+1]:=StrToInt(StringGrid2.Cells[i,j]);
    end;
BitBtn1.Enabled:=True;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
BitBtn3.Enabled:=True;
GenVals1.Active:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
i,j: Word;
begin
Try
Memo1.Lines.LoadFromFile('GenVals.txt');
Except
ShowMessage('Can not find file "GenVals.txt"')
end;
GenVals1.Number:=4;
for i:=0 to 3 do
    begin
    StringGrid4.Cells[i,0]:='0';
    StringGrid5.Cells[i,0]:='0';
      for j:=0 to 3 do
      begin
      StringGrid1.Cells[i,j]:='0';
      StringGrid2.Cells[i,j]:='0';
      StringGrid3.Cells[i,j]:='0';
      end;
    end;
With StringGrid1 do
     begin
     Cells[0,0]:='10';
     Cells[1,1]:='10';
     Cells[2,2]:='10';
     Cells[3,3]:='20';
     end;
With StringGrid2 do
     begin
     Cells[0,0]:='1000';
     Cells[1,1]:='2000';
     Cells[2,2]:='3000';
     Cells[3,3]:='5000';
     Cells[1,0]:='-1000';
     Cells[2,1]:='-1000';
     Cells[3,2]:='-2000';
     Cells[0,1]:='-1000';
     Cells[1,2]:='-1000';
     Cells[2,3]:='-2000';
     end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
WindowState:=wsMinimized;
AboutBox.ShowModal;
WindowState:=wsNormal;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
i,j: Word;
a: Double;
s: String;
begin
if (GenVals1.CalcValues)then
begin
for i:=0 to 3 do
begin
a:=Sqrt(GenVals1.Values^[i+1]);
Str(GenVals1.Values^[i+1]:7:2,s);
StringGrid4.Cells[i,0]:=s;
Str(a:7:2,s);
StringGrid5.Cells[i,0]:=s;
for j:=0 to 3 do
begin
Str(GenVals1.Forms^[i+1,j+1]:7:2,s);
StringGrid3.Cells[j,i]:=s;
end;
end;
end
else
ShowMessage('Error!');
BitBtn1.Enabled:=False;
BitBtn3.Enabled:=False;
GenVals1.Active:=False;
end;

procedure TForm1.GenVals1NotPositive(Sender: TObject);
begin
ShowMessage('Matrix is not positive definited');
end;

procedure TForm1.GenVals1NotSymmetrical(Sender: TObject);
begin
ShowMessage('Matrix is not symmetrical');
end;

end.
